Change some default values
[snf-image] / snf-image-host / common.sh.in
1 # Copyright (C) 2011 GRNET S.A. 
2 # Copyright (C) 2007, 2008, 2009 Google Inc.
3 #
4 # This program is free software; you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation; either version 2 of the License, or
7 # (at your option) any later version.
8 #
9 # This program is distributed in the hope that it will be useful, but
10 # WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
12 # General Public License for more details.
13 #
14 # You should have received a copy of the GNU General Public License
15 # along with this program; if not, write to the Free Software
16 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
17 # 02110-1301, USA.
18
19 AWK="awk"
20 LOSETUP="losetup"
21 KPARTX="kpartx"
22 SFDISK="sfdisk"
23 QEMU_IMG="qemu-img"
24 INSTALL_MBR="install-mbr"
25 TIMEOUT="timeout"
26 CURL="curl"
27 DATE="date -u" # Time in UTC
28
29 # Temporary use stderr as monitoring file descriptor.
30 # `create' will overwrite this
31 MONITOR_FD="2"
32
33 MSG_TYPE_ERROR="image-error"
34 MSG_TYPE_INFO="image-info"
35
36 CLEANUP=( )
37 ERROR_MSGS=( )
38
39 add_cleanup() {
40     local cmd=""
41     for arg; do cmd+=$(printf "%q " "$arg"); done
42     CLEANUP+=("$cmd")
43 }
44
45 log_error() {
46     echo "[ERROR] $*" >&2
47 }
48
49 report_error() {
50     ERROR_MSGS+=("$@")
51 }
52
53 report_info() {
54     local report
55     echo "[INFO] $*" >&2
56     report="$(./host-monitor.py info <<< "$*")"
57     eval "echo $(printf "%q" "$report") >&${MONITOR_FD}"
58 }
59
60
61 close_fd() {
62     local fd="$1"
63     exec {fd}>&-
64 }
65
66 send_errors() {
67     local report=""
68     if [ ${#ERROR_MSGS[@]} -gt 0 ]; then
69         local msg=""
70         for err in "${ERROR_MSGS[@]}"; do
71             msg+="$(echo "$err")"
72         done
73         report="$(./host-monitor.py error <<< "$msg")"
74     else
75         report=$(./host-monitor.py error <<< "Internal Error: Image deployment failed.")
76     fi
77
78     eval "echo $(printf "%q" "$report") >&${MONITOR_FD}"
79 }
80
81 get_api5_arguments() {
82     GETOPT_RESULT=$*
83     # Note the quotes around `$TEMP': they are essential!
84     eval set -- "$GETOPT_RESULT"
85     while true; do
86         case "$1" in
87             -i|-n) instance=$2; shift 2;;
88
89             -o) old_name=$2; shift 2;;
90
91             -b) blockdev=$2; shift 2;;
92
93             -s) swapdev=$2; shift 2;;
94
95             --) shift; break;;
96
97             *)  log_error "Internal error!" >&2; exit 1;;
98         esac
99     done
100     if [ -z "$instance" -o -z "$blockdev" ]; then
101         log_error "Missing OS API Argument (-i, -n, or -b)"
102         exit 1
103     fi
104     if [ "$SCRIPT_NAME" != "export" -a -z "$swapdev"  ]; then
105         log_error "Missing OS API Argument -s (swapdev)"
106         exit 1
107     fi
108     if [ "$SCRIPT_NAME" = "rename" -a -z "$old_name"  ]; then
109         log_error "Missing OS API Argument -o (old_name)"
110         exit 1
111     fi
112 }
113
114 get_api10_arguments() {
115     if [ -z "$INSTANCE_NAME" -o -z "$HYPERVISOR" -o -z "$DISK_COUNT" ]; then
116         log_error "Missing OS API Variable:"
117         log_error "(INSTANCE_NAME HYPERVISOR or DISK_COUNT)"
118         exit 1
119     fi
120     instance=$INSTANCE_NAME
121     if [ $DISK_COUNT -lt 1 -o -z "$DISK_0_PATH" ]; then
122         log_error "At least one disk is needed"
123         exit 1
124     fi
125     if [ "$SCRIPT_NAME" = "export" ]; then
126         if [ -z "$EXPORT_DEVICE" ]; then
127             log_error "Missing OS API Variable EXPORT_DEVICE"
128         fi
129         blockdev=$EXPORT_DEVICE
130     elif [ "$SCRIPT_NAME" = "import" ]; then
131         if [ -z "$IMPORT_DEVICE" ]; then
132         log_error "Missing OS API Variable IMPORT_DEVICE"
133         fi
134         blockdev=$IMPORT_DEVICE
135     else
136         blockdev=$DISK_0_PATH
137     fi
138     if [ "$SCRIPT_NAME" = "rename" -a -z "$OLD_INSTANCE_NAME" ]; then
139         log_error "Missing OS API Variable OLD_INSTANCE_NAME"
140     fi
141     old_name=$OLD_INSTANCE_NAME
142 }
143
144 get_api20_arguments() {
145     get_api10_arguments
146
147     local required_osparams="IMG_ID IMG_FORMAT IMG_PASSWD"
148     local osparams="$required_osparams IMG_PROPERTIES IMG_PERSONALITY CONFIG_URL"
149
150     # Store OSP_VAR in VAR
151     for param in $osparams; do
152         eval $param=\"\$OSP_$param\"
153     done
154
155     if [ -n "$CONFIG_URL" ]; then
156         local config config_params
157         config=$($CURL -f "$CONFIG_URL")
158         config_params=$(./decode-config.py $osparams <<< "$config")
159         eval "$config_params"
160     fi
161
162     for var in $required_osparams; do
163         if [ -z "${!var}" ]; then
164              log_error "Missing OS API Parameter: ${var}"
165              exit 1
166         fi
167     done
168 }
169
170 map_disk0() {
171     blockdev="$1"
172     filesystem_dev_base=$($KPARTX -l -p- $blockdev | \
173                             grep -m 1 -- "-1.*$blockdev" | \
174                             $AWK '{print $1}')
175     if [ -z "$filesystem_dev_base" ]; then
176         log_error "Cannot interpret kpartx output and get partition mapping"
177         exit 1
178     fi
179     $KPARTX -a -p- "$blockdev" > /dev/null
180     filesystem_dev="/dev/mapper/${filesystem_dev_base/%-1/}"
181     if [ ! -b "/dev/mapper/$filesystem_dev_base" ]; then
182         log_error "Can't find kpartx mapped partition:" \
183                                             "/dev/mapper/$filesystem_dev_base"
184         exit 1
185     fi
186     echo "$filesystem_dev"
187 }
188
189 unmap_disk0() {
190     $KPARTX -d -p- "$1"
191 }
192
193 format_disk0() {
194     local device="$1"
195     local image_type="$2"
196
197     declare -A part_id=( ['extdump']="83" ["ntfsdump"]="7" )
198
199     # The -f is needed, because we use an optimal alignment and sfdisk complains
200     # about partitions not ending on clylinder boundary.
201     local sfdisk_cmd="$SFDISK -uS -H 255 -S 63 -f --quiet --Linux --DOS $device"
202
203     $sfdisk_cmd > /dev/null <<EOF
204 2048,,${part_id["$image_type"]},*
205 EOF
206 }
207
208 create_floppy() {
209     local img target
210
211     img=$1
212
213     target=$(mktemp -d)
214     add_cleanup rmdir "$target"
215
216     dd bs=512 count=2880 if=/dev/zero of="$img"
217     mkfs.ext2 -F "$img" > /dev/null
218     mount "$img" "$target" -o loop
219     set | egrep ^snf_export_\\w+= | sed -e 's/^snf_export_/export SNF_IMAGE_/' \
220         > "$target/rules"
221     if [ -n "$UNATTEND" ]; then
222         if [ -f "$UNATTEND" ]; then
223             cat "$UNATTEND" > "$target/unattend.xml"
224         else
225             log_error "Unattend file: \`"$UNATTEND"' does not exist"
226         fi
227     fi
228     umount "$target"
229 }
230
231 get_backend_type() {
232     local id=$1
233
234     if [[ "$id" =~ ^pithos: ]]; then
235         echo "pithos"
236     elif [[ "$id" =~ ^pithosmap: ]]; then
237         echo "pithos"
238     elif [[ "$id" =~ ^(http|ftp)s?: ]]; then
239         if [ "$network_backend_support" = "yes" ]; then
240             echo "network";
241         else
242             log_error "Retrieving images from the network is not supported."
243             exit 1
244         fi
245     elif [ "$id" = "null" ]; then
246         echo "null"
247     else
248         echo "local"
249     fi
250 }
251
252 # this one is only to be called by create
253 ganeti_os_main() {
254     if [ -z "$OS_API_VERSION" -o "$OS_API_VERSION" = "5" ]; then
255         OS_API_VERSION=5
256         GETOPT_RESULT=`getopt -o o:n:i:b:s: -n '$0' -- "$@"`
257         if [ $? != 0 ] ; then log_error "Terminating..."; exit 1 ; fi
258         get_api5_arguments $GETOPT_RESULT
259     elif [ "$OS_API_VERSION" = "10" -o "$OS_API_VERSION" = "15" ]; then
260         get_api10_arguments
261     elif [ "$OS_API_VERSION" = "20" ]; then
262         get_api20_arguments
263         IMAGE_NAME="$IMG_ID"
264         IMAGE_TYPE="$IMG_FORMAT"
265         BACKEND_TYPE=$(get_backend_type $IMG_ID)
266     else
267         log_error "Unknown OS API VERSION $OS_API_VERSION"
268         exit 1
269     fi
270     
271     if [ -n "$OS_VARIANT" ]; then
272         if [ ! -d "$VARIANTS_DIR" ]; then
273             log_error "OS Variants directory $VARIANTS_DIR doesn't exist"
274             exit 1
275         fi
276         VARIANT_CONFIG="$VARIANTS_DIR/$OS_VARIANT.conf"
277         if [ -f "$VARIANT_CONFIG" ]; then
278             . "$VARIANT_CONFIG"
279         else
280             if grep -qxF "$OS_VARIANT" variants.list; then
281                 log_error "ERROR: instance-image configuration error"
282                 log_error "  Published variant $OS_VARIANT is missing its" \
283                     "config file"
284                 log_error "  Please create $VARIANT_CONFIG or unpublish the" \
285                     "variant"
286                 log_error "  (by removing $OS_VARIANT from variants.list)"
287             else
288                 log_error "Unofficial variant $OS_VARIANT is unsupported"
289                 log_error "Most probably this is a user error, forcing a" \
290                     "wrong name"
291                 log_error "To support this variant please create file" \
292                     "$VARIANT_CONFIG"
293             fi
294             exit 1
295         fi
296     fi
297
298 }
299
300 do_multistrap() {
301    local target="$1"
302    local cache="$2"
303    local pkgs="$3"
304
305     # Create preferences.d for apt
306     mkdir -p "$target/etc/apt/preferences.d"
307     if [ -d "$MULTISTRAP_APTPREFDIR" ]; then
308         find "$MULTISTRAP_APTPREFDIR" -maxdepth 1 -type f -exec cp {} "$target/etc/apt/preferences.d" \;
309     fi
310
311     # Create a policy-rc.d file to deny init script execution
312     mkdir -p "$target/usr/sbin"
313     cat > "$target/usr/sbin/policy-rc.d" <<EOF
314 #!/bin/sh
315 exit 101
316 EOF
317     chmod +x "$target/usr/sbin/policy-rc.d"
318
319    multistrap -d "$target" -f "$MULTISTRAP_CONFIG" 2>&1 | sed -u -e 's/^/MULTISTRAP: /g'
320
321    rm "$target/usr/sbin/policy-rc.d"
322    rm -rf "$target/etc/apt/preferences.d"
323 }
324
325 report_and_cleanup(){
326     send_errors
327     cleanup
328 }
329
330 cleanup() {
331     # if something fails here, it souldn't call cleanup again...
332     trap - EXIT
333
334     if [ ${#CLEANUP[*]} -gt 0 ]; then
335         LAST_ELEMENT=$((${#CLEANUP[*]}-1))
336         REVERSE_INDEXES=$(seq ${LAST_ELEMENT} -1 0)
337         for i in $REVERSE_INDEXES; do
338             # If something fails here, it's better to retry it for a few times
339             # before we give up with an error. This is needed for kpartx when
340             # dealing with ntfs partitions mounted through fuse. umount is not
341             # synchronous and may return while the partition is still busy. A
342             # premature attempt to delete partition mappings through kpartx on
343             # a device that hosts previously mounted ntfs partition may fail
344             # with errors like this one:
345             # `device-mapper: remove ioctl failed: Device or resource busy'
346             # A sensible workaround for this is to wait for a while and then
347             # retry it.
348             local cmd=${CLEANUP[$i]}
349             $cmd || for interval in 0.25 0.5 1 2 4; do
350             echo "Command $cmd failed!"
351             echo "I'll wait for $interval secs and will retry..."
352             sleep $interval
353             $cmd && break
354         done
355         if [ "$?" != "0" ]; then
356             echo "Giving Up..."
357             exit 1;
358         fi
359     done
360   fi
361 }
362
363 trap cleanup EXIT
364
365 DEFAULT_FILE="@sysconfdir@/default/snf-image"
366 if [ -f "$DEFAULT_FILE" ]; then
367     . "$DEFAULT_FILE"
368 fi
369
370 : ${VARIANTS_DIR:="@sysconfdir@/ganeti/snf-image/variants"}
371 : ${IMAGE_DIR:="@localstatedir@/lib/snf-image"}
372 : ${IMAGE_DEBUG:="no"}
373 : ${VERSION_CHECK:="@VERSION_CHECK@"}
374 : ${HELPER_DIR:="@HELPER_DIR@"}
375 : ${HELPER_SIZE:="600"}
376 : ${HELPER_SOFT_TIMEOUT:=120}
377 : ${HELPER_HARD_TIMEOUT:=5}
378 : ${HELPER_USER:="nobody"}
379 : ${PITHOS_DB:="sqlite:////@localstatedir@/lib/pithos/backend.db"}
380 : ${PITHOS_DATA:="@localstatedir@/lib/pithos/data/"}
381 : ${PROGRESS_MONITOR:="@PROGRESS_MONITOR@"}
382 : ${UNATTEND:="@UNATTEND@"}
383 : ${MULTISTRAP_CONFIG:="@MULTISTRAP_CONFIG@"}
384 : ${MULTISTRAP_APTPREFDIR:="@MULTISTRAP_APTPREFDIR@"}
385
386 SCRIPT_NAME=$(basename $0)
387
388 # vim: set sta sts=4 shiftwidth=4 sw=4 et ai :